<script setup lang="ts">
import { onBeforeMount, type Ref, ref } from 'vue'
import { useMoviesStore } from '@/stores/movies'
import MoviesList from '@/components/MoviesList.vue'
import TheFilters from '@/components/TheFilters.vue'
import TheLoader from '@/components/TheLoader.vue'
import EmptyState from '@/components/EmptyState.vue'

const moviesStore = useMoviesStore()

onBeforeMount(async () => {
  moviesStore.loading = true

  await moviesStore.getMovies()

  moviesStore.loading = false
})
</script>

<template>
  <TheFilters/>
  <TheLoader v-if="moviesStore.loading"/>
  <div v-else>
    <MoviesList v-if="moviesStore.movies && moviesStore.movies.length > 0"/>
    <EmptyState v-else/>
  </div>
</template>
